--- Variables: ---
previousSpell = nil;

sounds = {};

sounds.ryu = "Interface\\AddOns\\Hadouken\\media\\sounds\\RyuHadouken.mp3";
sounds.ken = "Interface\\AddOns\\Hadouken\\media\\sounds\\KenHadouken.mp3";
sounds.sakura = "Interface\\AddOns\\Hadouken\\media\\sounds\\SakuraHadouken.mp3";
	
savedVariables = {};
savedVariables.spells = {};
savedVariables.sound = "ryu";
savedVariables.personal = true;


--- Slash commands: ---
SLASH_HADOUKEN1 = "/hadouken";
SLASH_HADOUKEN2 = "/ha";

spellTracker = CreateFrame("Frame", nil, UIParent);
spellTracker:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
spellTracker:SetScript("OnEvent", eventHandler);

function eventHandler(self, event, ...)
spellCaster, spellName, _, spellCount = ...;

	if previousSpell ~= spellCount then
	
		spellName = GetSpellLink(spellName);
	
 		if savedVariables.personal and spellCaster == "player" or savedVariables.personal == false then
			
			for i, v in ipairs(savedVariables.spells) do
				if spellName == savedVariables.spells[i] then
					PlaySoundFile(sounds[savedVariables.sound]);
				end;
				
			end;
		end;
	end;
	
	previousSpell = spellCount;
	
end;




function showHelp()
	printMessege("|cFFFFFF00/hadouken <spell name> |rAdds/removes the HADOUKEN sound to a spell.");
	printMessege("|cFFFFFF00/hadouken list |rLists the spells you have added the HADOUKEN sound to.");
	printMessege("|cFFFFFF00/hadouken Ryu / Ken / Sakura |rSets the HADOUKEN sound to match the chosen character.");
	printMessege("|cFFFFFF00/hadouken global |rEnables the HADOUKEN sound on spells cast by other players.");
	printMessege("|cFFFFFF00/hadouken personal |rDisables the HADOUKEN sound on spells cast by other players.");
	printMessege("|cFFFFFF00/hadouken clear |rClears the list of spells you have added the HADOUKEN sound to.");
end;

function SlashCmdList.HADOUKEN(spell)
	if spell == "" or spell == "Help" or spell == "help" then 
		showHelp();
		return;
	elseif spell == "List" or spell == "list" then 
		listSpells();
		return;
	elseif spell == "Clear" or spell == "clear" then 
		savedVariables.spells = {};
		printMessege("Your list of HADOUKEN'ed spells has been cleared.");
		return;
	elseif spell == "Global" or spell == "global" then 
		savedVariables.personal = false;
		printMessege("The HADOUKEN sound will now trigger on spells cast by other players.");
		return;
	elseif spell == "Personal" or spell == "personal" then 
		savedVariables.personal = true;
		printMessege("The HADOUKEN sound will now only trigger on spells cast by you.");
		return;
	elseif spell == "Sakura" or spell == "sakura" then 
		savedVariables.sound = "sakura";
		printMessege("Your HADOUKEN sound has been set to \"Sakura\".");
		return;
	elseif spell == "Ken" or spell == "ken" then 
		savedVariables.sound = "ken";
		printMessege("Your HADOUKEN sound has been set to \"Ken\".");
		return;
	elseif spell == "Ryu"  or spell == "ryu" then 
		savedVariables.sound = "ryu";
		printMessege("Your HADOUKEN sound has been set to \"Ryu\".");
		return;
	else
		addRemoveSpell(spell);
	end;
	
end;

function listSpells()
	printMessege("List of HADOUKEN'ed spells:");
	for i, spell in ipairs(savedVariables.spells) do printMessege(spell) end;
end;

function addRemoveSpell(spell)
	
	spell = validateSpell(spell);
	
	if spell == nil then
		printMessege("Invalid command or spell. Please check your spelling.");
		return ;
	end;
	
	addSpell = true;
	
	for i, savedSpell in ipairs(savedVariables.spells) do
		if savedSpell == spell then
			table.remove(savedVariables.spells, i);
			printMessege(savedSpell .. " has been removed.");
			
			addSpell = false;
			
			break;
		end;
	end;
			
	if addSpell then
		table.insert(savedVariables.spells, spell);
		printMessege(spell .. " has been added.");
	end;
	
end;

function validateSpell(spell)
	if GetSpellLink(spell) then
		return GetSpellLink(spell);
	else
		return nil;
	end;
end;

function printMessege(text)
	print("|cFF00FF00HADOUKEN:|r " .. text);
end;